# Interface DeepClientInstance<L>

interface DeepClientInstance<L> {
DeepClient: typeof DeepClient;
DeepContext: Context<DeepClient<Link<Id>>>;
DeepProvider: ((__namedParameters: {
apolloClient?: IApolloClient<any>;
children: any;
minilinks?: MinilinkCollection<MinilinksGeneratorOptions, Link<Id>>;
namespace?: string;
}) => Element);
apolloClient: IApolloClient<any>;
deep: DeepClientInstance<L>;
defaultDeleteName?: string;
defaultInsertName?: string;
defaultSelectName?: string;
defaultUpdateName?: string;
deleteReturning?: string;
filesSelectReturning?: string;
handleAuth?: ((linkId?: Id, token?: string) => any);
insertReturning?: string;
linkId?: Id;
linksSelectReturning?: string;
minilinks: MinilinksResult<L>;
namespace?: string;
returning?: string;
selectReturning?: string;
selectorsSelectReturning?: string;
table?: string;
token?: string;
unsafe?: any;
updateReturning?: string;
useDeep: (() => DeepClient<Link<Id>>);
useDeepId: ((start: QueryLink | DeepClientStartItem, ...path: DeepClientPathItem[]) => {
data: Id;
error?: any;
loading: boolean;
});
useDeepQuery: (<Table, LL>(query: Exp<Table>, options?: Options<Table>) => {
data?: LL[];
error?: any;
loading: boolean;
});
useDeepSubscription: (<Table, LL>(query: Exp<Table>, options?: Options<Table>) => UseDeepSubscriptionResult<LL>);
useMinilinksQuery: ((query: Exp<"links">) => L[]);
useMinilinksSubscription: ((query: Exp<"links">) => L[]);
valuesSelectReturning?: string;
Traveler(links: Link<Id>[]): Traveler;
await(id: Id): Promise<boolean>;
can(objectIds: Id[], subjectIds: Id[], actionIds: Id[]): Promise<boolean>;
delete<TTable>(exp: Exp<TTable>, options?: WriteOptions<TTable>): Promise<DeepClientResult<{
id: any;
}[]>>;
guest(options: DeepClientGuestOptions): Promise<DeepClientAuthResult>;
id(start:
| string
| number
| QueryLink
| Id[], ...path: DeepClientPathItem[]): Promise<Id>;
idLocal(start: DeepClientStartItem, ...path: DeepClientPathItem[]): Id;
insert<TTable, LL>(objects: InsertObjects<TTable>, options?: WriteOptions<TTable>): Promise<DeepClientResult<{
id: any;
}[]>>;
jwt(options: DeepClientJWTOptions): Promise<DeepClientAuthResult>;
login(options: DeepClientJWTOptions): Promise<DeepClientAuthResult>;
logout(): Promise<DeepClientAuthResult>;
reserve<LL>(count: number): Promise<Id[]>;
select<TTable, LL>(exp: Exp<TTable>, options?: ReadOptions<TTable>): Promise<DeepClientResult<number | LL[]>>;
serial(options: AsyncSerialParams): Promise<DeepClientResult<{
id: any;
}[]>>;
serializeQuery(exp: any, env?: string): any;
serializeWhere(exp: any, env?: string): any;
stringify(any?: any): string;
subscribe<TTable, LL>(exp: Exp<TTable>, options?: ReadOptions<TTable>): Observable<number | LL[]>;
unvertualizeId(id: Id): Id;
update<TTable>(exp: Exp<TTable>, value: UpdateValue<TTable>, options?: WriteOptions<TTable>): Promise<DeepClientResult<{
id: any;
}[]>>;
}

#### Type Parameters

- L extends Link<Id> = Link<Id>

#### Hierarchy (view full)

- DeepClientInstance
  - CyberDeepClientInstance

#### Implemented by

- DeepClient

- Defined in work/deeplinks/deeplinks/imports/client.tsx:357

#####
Index

### Properties

DeepClient
DeepContext
DeepProvider
apolloClient
deep
defaultDeleteName?
defaultInsertName?
defaultSelectName?
defaultUpdateName?
deleteReturning?
filesSelectReturning?
handleAuth?
insertReturning?
linkId?
linksSelectReturning?
minilinks
namespace?
returning?
selectReturning?
selectorsSelectReturning?
table?
token?
unsafe?
updateReturning?
useDeep
useDeepId
useDeepQuery
useDeepSubscription
useMinilinksQuery
useMinilinksSubscription
valuesSelectReturning?

### Methods

Traveler
await
can
delete
guest
id
idLocal
insert
jwt
login
logout
reserve
select
serial
serializeQuery
serializeWhere
stringify
subscribe
unvertualizeId
update

##
Properties

### DeepClient

DeepClient: typeof DeepClient

- Defined in work/deeplinks/deeplinks/imports/client.tsx:365

### DeepContext

DeepContext: Context<DeepClient<Link<Id>>>

- Defined in work/deeplinks/deeplinks/imports/client.tsx:430

### DeepProvider

DeepProvider: ((__namedParameters: {
apolloClient?: IApolloClient<any>;
children: any;
minilinks?: MinilinkCollection<MinilinksGeneratorOptions, Link<Id>>;
namespace?: string;
}) => Element)

- Defined in work/deeplinks/deeplinks/imports/client.tsx:429

### apolloClient

apolloClient: IApolloClient<any>

- Defined in work/deeplinks/deeplinks/imports/client.tsx:367

### deep

deep: DeepClientInstance<L>

- Defined in work/deeplinks/deeplinks/imports/client.tsx:364

### `Optional` defaultDeleteName

defaultDeleteName?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:384

### `Optional` defaultInsertName

defaultInsertName?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:382

### `Optional` defaultSelectName

defaultSelectName?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:381

### `Optional` defaultUpdateName

defaultUpdateName?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:383

### `Optional` deleteReturning

deleteReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:379

### `Optional` filesSelectReturning

filesSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:376

### `Optional` handleAuth

handleAuth?: ((linkId?: Id, token?: string) => any)

- Defined in work/deeplinks/deeplinks/imports/client.tsx:362

### `Optional` insertReturning

insertReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:377

### `Optional` linkId

linkId?: Id

- Defined in work/deeplinks/deeplinks/imports/client.tsx:360

### `Optional` linksSelectReturning

linksSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:373

### minilinks

minilinks: MinilinksResult<L>

- Defined in work/deeplinks/deeplinks/imports/client.tsx:368

### `Optional` namespace

namespace?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:358

### `Optional` returning

returning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:370

### `Optional` selectReturning

selectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:372

### `Optional` selectorsSelectReturning

selectorsSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:375

### `Optional` table

table?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:369

### `Optional` token

token?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:361

### `Optional` unsafe

unsafe?: any

- Defined in work/deeplinks/deeplinks/imports/client.tsx:386

### `Optional` updateReturning

updateReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:378

### useDeep

useDeep: (() => DeepClient<Link<Id>>)

- Defined in work/deeplinks/deeplinks/imports/client.tsx:428

### useDeepId

useDeepId: ((start: QueryLink | DeepClientStartItem, ...path: DeepClientPathItem[]) => {
data: Id;
error?: any;
loading: boolean;
})

- Defined in work/deeplinks/deeplinks/imports/client.tsx:423

### useDeepQuery

useDeepQuery: (<Table, LL>(query: Exp<Table>, options?: Options<Table>) => {
data?: LL[];
error?: any;
loading: boolean;
})

- Defined in work/deeplinks/deeplinks/imports/client.tsx:425

### useDeepSubscription

useDeepSubscription: (<Table, LL>(query: Exp<Table>, options?: Options<Table>) => UseDeepSubscriptionResult<LL>)

- Defined in work/deeplinks/deeplinks/imports/client.tsx:424

### useMinilinksQuery

useMinilinksQuery: ((query: Exp<"links">) => L[])

- Defined in work/deeplinks/deeplinks/imports/client.tsx:426

### useMinilinksSubscription

useMinilinksSubscription: ((query: Exp<"links">) => L[])

- Defined in work/deeplinks/deeplinks/imports/client.tsx:427

### `Optional` valuesSelectReturning

valuesSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:374

##
Methods

### Traveler

- Traveler(links): Traveler

- #### Parameters

  - links: Link<Id>[]

  #### Returns Traveler

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:432

### await

- await(id): Promise<boolean>

- #### Parameters

  - id: Id

  #### Returns Promise<boolean>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:403

### can

- can(objectIds, subjectIds, actionIds): Promise<boolean>

- #### Parameters

  - objectIds: Id[]
  - subjectIds: Id[]
  - actionIds: Id[]

  #### Returns Promise<boolean>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:421

### delete

- delete<TTable>(exp, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - TTable extends
    | "links"
    | "numbers"
    | "strings"
    | "objects"

  #### Parameters

  - exp: Exp<TTable>
  - `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:397

### guest

- guest(options): Promise<DeepClientAuthResult>

- #### Parameters

  - options: DeepClientGuestOptions

  #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:413

### id

- id(start, ...path): Promise<Id>

- #### Parameters

  - start:
    | string
    | number
    | QueryLink
    | Id[]
  - `Rest`...path: DeepClientPathItem[]

  #### Returns Promise<Id>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:410

### idLocal

- idLocal(start, ...path): Id

- #### Parameters

  - start: DeepClientStartItem
  - `Rest`...path: DeepClientPathItem[]

  #### Returns Id

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:411

### insert

- insert<TTable, LL>(objects, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - TTable extends
    | "links"
    | "numbers"
    | "strings"
    | "objects"
  - LL = L

  #### Parameters

  - objects: InsertObjects<TTable>
  - `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:393

### jwt

- jwt(options): Promise<DeepClientAuthResult>

- #### Parameters

  - options: DeepClientJWTOptions

  #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:415

### login

- login(options): Promise<DeepClientAuthResult>

- #### Parameters

  - options: DeepClientJWTOptions

  #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:417

### logout

- logout(): Promise<DeepClientAuthResult>

- #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:419

### reserve

- reserve<LL>(count): Promise<Id[]>

- #### Type Parameters

  - LL = L

  #### Parameters

  - count: number

  #### Returns Promise<Id[]>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:401

### select

- select<TTable, LL>(exp, options?): Promise<DeepClientResult<number | LL[]>>

- #### Type Parameters

  - TTable extends
    | "links"
    | "can"
    | "tree"
    | "selectors"
    | "numbers"
    | "strings"
    | "objects"
    | "handlers"
  - LL = L

  #### Parameters

  - exp: Exp<TTable>
  - `Optional` options: ReadOptions<TTable>

  #### Returns Promise<DeepClientResult<number | LL[]>>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:390

### serial

- serial(options): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Parameters

  - options: AsyncSerialParams

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:399

### serializeQuery

- serializeQuery(exp, env?): any

- #### Parameters

  - exp: any
  - `Optional` env: string

  #### Returns any

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:407

### serializeWhere

- serializeWhere(exp, env?): any

- #### Parameters

  - exp: any
  - `Optional` env: string

  #### Returns any

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:406

### stringify

- stringify(any?): string

- #### Parameters

  - `Optional` any: any

  #### Returns string

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:388

### subscribe

- subscribe<TTable, LL>(exp, options?): Observable<number | LL[]>

- #### Type Parameters

  - TTable extends
    | "links"
    | "can"
    | "tree"
    | "selectors"
    | "numbers"
    | "strings"
    | "objects"
    | "handlers"
  - LL = L

  #### Parameters

  - exp: Exp<TTable>
  - `Optional` options: ReadOptions<TTable>

  #### Returns Observable<number | LL[]>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:391

### unvertualizeId

- unvertualizeId(id): Id

- #### Parameters

  - id: Id

  #### Returns Id

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:408

### update

- update<TTable>(exp, value, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - TTable extends
    | "links"
    | "numbers"
    | "strings"
    | "objects"

  #### Parameters

  - exp: Exp<TTable>
  - value: UpdateValue<TTable>
  - `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:395